/******************************************************************************
* getopt_auto.h - $Revision: 1.2 $ - $Date: 2004/11/14 19:28:28 $
*
*   Copyright (C) 2004 Craig B. Agricola (craig@theagricolas.org)
*
* This is the header file for getopt_auto.c
* See getopt_auto.c for usage and license information.
*
******************************************************************************/

#define SPACE_CHAR ' '

#define GETOPT_AUTO_VALUE_OFFSET(s, f) ((int)(&(((s*)0)->f)))

typedef enum {
  GETOPT_AUTO_STRING_ARG = 0,
  GETOPT_AUTO_INTEGER_ARG,
  GETOPT_AUTO_DOUBLE_ARG,
  GETOPT_AUTO_NUM_ARG_TYPES
} getopt_auto_arg_type_e;

struct getopt_auto_option_s {
  char                   *name;
  char                    short_char;
  void                   *storage;
  int                     has_arg;
  getopt_auto_arg_type_e  arg_type;
  char                   *help_string;
};

void print_help(char *usage, struct getopt_auto_option_s *options);

int getopt_auto(int argc, char *argv[],
                char *usage_str,
                struct getopt_auto_option_s *auto_opts);
